package com.qxgmat.data.dao.entity;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.*;

@Table(name = "user_paper")
public class UserPaper implements Serializable {
    @Id
    @Column(name = "`id`")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    /**
     * 用户id
     */
    @Column(name = "`user_id`")
    private Integer userId;

    /**
     * 组卷名称
     */
    @Column(name = "`title`")
    private String title;

    /**
     * 组卷模块：examination，exercise，collect，error，homework_preview
     */
    @Column(name = "`module`")
    private String module;

    /**
     * 对应模块id
     */
    @Column(name = "`module_id`")
    private Integer moduleId;

    /**
     * 题目编号id列表：json
     */
    @Column(name = "`question_no_ids`")
    private Integer[] questionNoIds;

    /**
     * 练习次数
     */
    @Column(name = "`times`")
    private Integer times;

    /**
     * 总时间
     */
    @Column(name = "`time`")
    private Integer time;

    /**
     * 用户做题时间-累计
     */
    @Column(name = "`user_time`")
    private Integer userTime;

    /**
     * 正确总题数-累计
     */
    @Column(name = "`correct_number`")
    private Integer correctNumber;

    /**
     * 删除时间
     */
    @Column(name = "`delete_time`")
    private Date deleteTime;

    private static final long serialVersionUID = 1L;

    /**
     * @return id
     */
    public Integer getId() {
        return id;
    }

    /**
     * @param id
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 获取用户id
     *
     * @return user_id - 用户id
     */
    public Integer getUserId() {
        return userId;
    }

    /**
     * 设置用户id
     *
     * @param userId 用户id
     */
    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    /**
     * 获取组卷名称
     *
     * @return title - 组卷名称
     */
    public String getTitle() {
        return title;
    }

    /**
     * 设置组卷名称
     *
     * @param title 组卷名称
     */
    public void setTitle(String title) {
        this.title = title;
    }

    /**
     * 获取组卷模块：examination，exercise，collect，error，homework_preview
     *
     * @return module - 组卷模块：examination，exercise，collect，error，homework_preview
     */
    public String getModule() {
        return module;
    }

    /**
     * 设置组卷模块：examination，exercise，collect，error，homework_preview
     *
     * @param module 组卷模块：examination，exercise，collect，error，homework_preview
     */
    public void setModule(String module) {
        this.module = module;
    }

    /**
     * 获取对应模块id
     *
     * @return module_id - 对应模块id
     */
    public Integer getModuleId() {
        return moduleId;
    }

    /**
     * 设置对应模块id
     *
     * @param moduleId 对应模块id
     */
    public void setModuleId(Integer moduleId) {
        this.moduleId = moduleId;
    }

    /**
     * 获取题目编号id列表：json
     *
     * @return question_no_ids - 题目编号id列表：json
     */
    public Integer[] getQuestionNoIds() {
        return questionNoIds;
    }

    /**
     * 设置题目编号id列表：json
     *
     * @param questionNoIds 题目编号id列表：json
     */
    public void setQuestionNoIds(Integer[] questionNoIds) {
        this.questionNoIds = questionNoIds;
    }

    /**
     * 获取练习次数
     *
     * @return times - 练习次数
     */
    public Integer getTimes() {
        return times;
    }

    /**
     * 设置练习次数
     *
     * @param times 练习次数
     */
    public void setTimes(Integer times) {
        this.times = times;
    }

    /**
     * 获取总时间
     *
     * @return time - 总时间
     */
    public Integer getTime() {
        return time;
    }

    /**
     * 设置总时间
     *
     * @param time 总时间
     */
    public void setTime(Integer time) {
        this.time = time;
    }

    /**
     * 获取用户做题时间-累计
     *
     * @return user_time - 用户做题时间-累计
     */
    public Integer getUserTime() {
        return userTime;
    }

    /**
     * 设置用户做题时间-累计
     *
     * @param userTime 用户做题时间-累计
     */
    public void setUserTime(Integer userTime) {
        this.userTime = userTime;
    }

    /**
     * 获取正确总题数-累计
     *
     * @return correct_number - 正确总题数-累计
     */
    public Integer getCorrectNumber() {
        return correctNumber;
    }

    /**
     * 设置正确总题数-累计
     *
     * @param correctNumber 正确总题数-累计
     */
    public void setCorrectNumber(Integer correctNumber) {
        this.correctNumber = correctNumber;
    }

    /**
     * 获取删除时间
     *
     * @return delete_time - 删除时间
     */
    public Date getDeleteTime() {
        return deleteTime;
    }

    /**
     * 设置删除时间
     *
     * @param deleteTime 删除时间
     */
    public void setDeleteTime(Date deleteTime) {
        this.deleteTime = deleteTime;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", userId=").append(userId);
        sb.append(", title=").append(title);
        sb.append(", module=").append(module);
        sb.append(", moduleId=").append(moduleId);
        sb.append(", questionNoIds=").append(questionNoIds);
        sb.append(", times=").append(times);
        sb.append(", time=").append(time);
        sb.append(", userTime=").append(userTime);
        sb.append(", correctNumber=").append(correctNumber);
        sb.append(", deleteTime=").append(deleteTime);
        sb.append("]");
        return sb.toString();
    }

    public static UserPaper.Builder builder() {
        return new UserPaper.Builder();
    }

    public static class Builder {
        private UserPaper obj;

        public Builder() {
            this.obj = new UserPaper();
        }

        /**
         * @param id
         */
        public Builder id(Integer id) {
            obj.setId(id);
            return this;
        }

        /**
         * 设置用户id
         *
         * @param userId 用户id
         */
        public Builder userId(Integer userId) {
            obj.setUserId(userId);
            return this;
        }

        /**
         * 设置组卷名称
         *
         * @param title 组卷名称
         */
        public Builder title(String title) {
            obj.setTitle(title);
            return this;
        }

        /**
         * 设置组卷模块：examination，exercise，collect，error，homework_preview
         *
         * @param module 组卷模块：examination，exercise，collect，error，homework_preview
         */
        public Builder module(String module) {
            obj.setModule(module);
            return this;
        }

        /**
         * 设置对应模块id
         *
         * @param moduleId 对应模块id
         */
        public Builder moduleId(Integer moduleId) {
            obj.setModuleId(moduleId);
            return this;
        }

        /**
         * 设置题目编号id列表：json
         *
         * @param questionNoIds 题目编号id列表：json
         */
        public Builder questionNoIds(Integer[] questionNoIds) {
            obj.setQuestionNoIds(questionNoIds);
            return this;
        }

        /**
         * 设置总时间
         *
         * @param time 总时间
         */
        public Builder time(Integer time) {
            obj.setTime(time);
            return this;
        }

        /**
         * 设置练习次数
         *
         * @param times 练习次数
         */
        public Builder times(Integer times) {
            obj.setTimes(times);
            return this;
        }

        /**
         * 设置用户做题时间-累计
         *
         * @param userTime 用户做题时间-累计
         */
        public Builder userTime(Integer userTime) {
            obj.setUserTime(userTime);
            return this;
        }

        /**
         * 设置正确总题数-累计
         *
         * @param correctNumber 正确总题数-累计
         */
        public Builder correctNumber(Integer correctNumber) {
            obj.setCorrectNumber(correctNumber);
            return this;
        }

        /**
         * 设置删除时间
         *
         * @param deleteTime 删除时间
         */
        public Builder deleteTime(Date deleteTime) {
            obj.setDeleteTime(deleteTime);
            return this;
        }

        public UserPaper build() {
            return this.obj;
        }
    }
}